## gstreamer-imx 0.11.1

=== wscript ===
#!/usr/bin/env python


from waflib.Build import BuildContext, CleanContext, InstallContext, UninstallContext, Logs

top = '.'
out = 'build'

gstimx_version = "0.11.1"

# the code inside fragment deliberately does an unsafe implicit cast float->char to trigger a
# compiler warning; sometimes, gcc does not tell about an unsupported parameter *unless* the
# code being compiled causes a warning
c_cflag_check_code = """
int main()
{
	float f = 4.0;
	char c = f;
	return c - 4;
}
"""
def check_compiler_flag(conf, flag, lang):
	return conf.check(fragment = c_cflag_check_code, mandatory = 0, execute = 0, define_ret = 0, msg = 'Checking for compiler switch %s' % flag, cxxflags = conf.env[lang + 'FLAGS'] + [flag], okmsg = 'yes', errmsg = 'no')  
def check_compiler_flags_2(conf, cflags, ldflags, msg):
	Logs.pprint('NORMAL', msg)
	return conf.check(fragment = c_cflag_check_code, mandatory = 0, execute = 0, define_ret = 0, msg = 'Checking if building with these flags works', cxxflags = cflags, ldflags = ldflags, okmsg = 'yes', errmsg = 'no')


def add_compiler_flags(conf, env, flags, lang, compiler, uselib = ''):
	for flag in reversed(flags):
		if type(flag) == type(()):
			flag_candidate = flag[0]
			flag_alternative = flag[1]
		else:
			flag_candidate = flag
			flag_alternative = None

		if uselib:
			flags_pattern = lang + 'FLAGS_' + uselib
		else:
			flags_pattern = lang + 'FLAGS'

		if check_compiler_flag(conf, flag_candidate, compiler):
			env.prepend_value(flags_pattern, [flag_candidate])
		elif flag_alternative:
			if check_compiler_flag(conf, flag_alternative, compiler):
				env.prepend_value(flags_pattern, [flag_alternative])


def options(opt):
	opt.add_option('--enable-debug', action = 'store_true', default = False, help = 'enable debug build [default: %default]')
	opt.add_option('--with-package-name', action = 'store', default = "Unknown package release", help = 'specify package name to use in plugin [default: %default]')
	opt.add_option('--with-package-origin', action = 'store', default = "Unknown package origin", help = 'specify package origin URL to use in plugin [default: %default]')
	opt.add_option('--plugin-install-path', action = 'store', default = "${PREFIX}/lib/gstreamer-1.0", help = 'where to install the plugin for GStreamer 1.0 [default: %default]')
	opt.add_option('--kernel-headers', action = 'store', default = None, help = 'specify path to the kernel headers')
	opt.add_option('--build-for-android', action = 'store_true', default = False, help = 'build with Android support [default: %default]')
	opt.load('compiler_c')
	opt.load('gnu_dirs')
	opt.recurse('src/eglvivsink')


def check_linux_headers(conf):
	import os
	incpaths = []
	extra_incpaths = []
	notfound = None
	if conf.options.kernel_headers:
		kernel_headers_fullpath = os.path.abspath(os.path.expanduser(conf.options.kernel_headers))
		incpaths += [kernel_headers_fullpath]
		extra_incpaths += [os.path.abspath(os.path.expanduser(os.path.join(kernel_headers_fullpath, '..', 'usr', 'include')))]
	# for the test, make sure the right version.h is used by adding an include path to
	# <kernel_headers_fullpath>/../usr/include
	with_uapi = conf.check_cc(fragment = '''
		#include <linux/version.h>
		int main() {
		#if LINUX_VERSION_CODE > KERNEL_VERSION(3, 5, 0)
			return 0;
		#else
		#error fail
		#endif
		}
		''',
		includes = incpaths + extra_incpaths,
		mandatory = False,
		execute = False,
		msg = 'checking whether or not the kernel version is greater than 3.5.0'
	)
	if conf.options.kernel_headers:
		if with_uapi:
			incpaths = [os.path.join(kernel_headers_fullpath, 'uapi')] + incpaths
	if incpaths:
		conf.env['INCLUDES_KERNEL_HEADERS'] = incpaths


def configure(conf):
	import os

	conf.load('compiler_c')
	conf.load('gnu_dirs')

	# check and add compiler flags

	if conf.env['CFLAGS'] and conf.env['LINKFLAGS']:
		check_compiler_flags_2(conf, conf.env['CFLAGS'], conf.env['LINKFLAGS'], "Need to test compiler flags %s and linker flags %s" % (' '.join(conf.env['CFLAGS']), ' '.join(conf.env['LINKFLAGS'])))
	elif conf.env['CFLAGS']:
		check_compiler_flags_2(conf, conf.env['CFLAGS'], '', "Need to test compiler flags %s" % ' '.join(conf.env['CFLAGS']))
	elif conf.env['LINKFLAGS']:
		check_compiler_flags_2(conf, '', conf.env['LINKFLAGS'], "Need to test linker flags %s" % ' '.join(conf.env['LINKFLAGS']))

	compiler_flags = ['-Wextra', '-Wall', '-std=gnu99', '-fPIC', '-DPIC']
	if conf.options.enable_debug:
		compiler_flags += ['-O0', '-g3', '-ggdb']
	else:
		compiler_flags += ['-O2']

	add_compiler_flags(conf, conf.env, compiler_flags, 'C', 'C')

	add_compiler_flags(conf, conf.env, ['-Wno-unused-parameter', '-Wno-missing-field-initializers', '-Wno-sign-compare'], 'C', 'C', 'GSTBACKPORT')

	# Disable warning about including kernel headers. This is generally not a good idea, but some APIs like IPU and PxP
	# leave no other choice, since there are no (reliable) userspace libraries/headers for these.
	add_compiler_flags(conf, conf.env, ['-Wno-cpp'], 'C', 'C', 'KERNEL_HEADERS')


	# configure objdump utility
	try:
		conf.env['OBJDUMP'] = os.environ['OBJDUMP']
		conf.msg(msg = 'Checking for program objdump', result = conf.env['OBJDUMP'])
	except KeyError as e:
		conf.env['OBJDUMP'] = conf.find_program('objdump', var = 'OBJDUMP')


	# some extra output for Android
	conf.msg('Building for Android', result = 'yes' if conf.options.build_for_android else 'no', color = 'GREEN' if conf.options.build_for_android else 'YELLOW')
	if conf.options.build_for_android:
		conf.define('BUILD_FOR_ANDROID', 1)
		conf.define('GST_PLUGIN_BUILD_STATIC', 1)
		conf.env['BUILD_FOR_ANDROID'] = True
		conf.env['CLIBTYPE'] = 'cstlib' # Cannot use shared library builds of gstreamer-imx with Android
	else:
		conf.env['CLIBTYPE'] = 'cshlib'


	# test for miscellaneous system libraries

	conf.check_cc(lib = 'dl', uselib_store = 'DL', mandatory = 1)
	conf.check_cc(lib = 'm', uselib_store = 'M', mandatory = 1)

	# Android's libc (called "bionic") includes the pthreads library, however it still needs the -pthread flag
	if conf.options.build_for_android or conf.check_cc(lib = 'pthread', uselib_store = 'PTHREAD', mandatory = 1):
		conf.env['CFLAGS_PTHREAD'] += ['-pthread']


	# test for GStreamer libraries

	conf.check_cfg(package = 'gstreamer-1.0 >= 1.2.0', uselib_store = 'GSTREAMER', args = '--cflags --libs', mandatory = 1)
	conf.check_cfg(package = 'gstreamer-base-1.0 >= 1.2.0', uselib_store = 'GSTREAMER_BASE', args = '--cflags --libs', mandatory = 1)
	conf.check_cfg(package = 'gstreamer-audio-1.0 >= 1.2.0', uselib_store = 'GSTREAMER_VIDEO', args = '--cflags --libs', mandatory = 0)
	conf.check_cfg(package = 'gstreamer-video-1.0 >= 1.2.0', uselib_store = 'GSTREAMER_VIDEO', args = '--cflags --libs', mandatory = 1)
	if conf.check_cc(lib = 'gstphotography-1.0', uselib_store = 'GSTPHOTOGRAPHY', mandatory = 0):
		conf.env['WITH_GSTPHOTOGRAPHY'] = True


	# check the kernel header path

	check_linux_headers(conf)


	# misc definitions & env vars

	conf.env['PLUGIN_INSTALL_PATH'] = os.path.expanduser(conf.options.plugin_install_path)
	if conf.env['BUILD_FOR_ANDROID']:
		conf.env['PLUGIN_INSTALL_PATH'] = os.path.join(conf.env['PLUGIN_INSTALL_PATH'], 'static')

	conf.define('GST_PACKAGE_NAME', conf.options.with_package_name)
	conf.define('GST_PACKAGE_ORIGIN', conf.options.with_package_origin)
	conf.define('PACKAGE', "gstreamer-imx")
	conf.define('PACKAGE_BUGREPORT', "https://github.com/Freescale/gstreamer-imx")
	conf.define('VERSION', gstimx_version)

	conf.env['GSTIMX_VERSION'] = gstimx_version
	conf.env['COMMON_USELIB'] = ['GSTREAMER', 'GSTREAMER_BASE', 'GSTREAMER_AUDIO', 'GSTREAMER_VIDEO', 'PTHREAD', 'M']


	conf.recurse('src/common')
	conf.recurse('src/g2d')
	conf.recurse('src/pxp')
	conf.recurse('src/ipu')
	conf.recurse('src/vpu')
	conf.recurse('src/eglvivsink')
	conf.recurse('src/v4l2src')
	conf.recurse('src/audio')


	conf.write_config_header('config.h')



def build(bld):
	bld.recurse('src/common')
	bld.recurse('src/g2d')
	bld.recurse('src/pxp')
	bld.recurse('src/ipu')
	bld.recurse('src/vpu')
	bld.recurse('src/eglvivsink')
	bld.recurse('src/v4l2src')
	bld.recurse('src/audio')
	bld.recurse('src/blitter')
	bld.recurse('src/compositor')

=== audio/wscript ===
#!/usr/bin/env python


import os, re
from waflib import Logs, Errors


def add_fslcodec(conf, desc, codec_name, arm_core, gstcaps):
	try:
		orig_codec_fn = "lib_%s_wrap_%s_elinux.so" % (codec_name, arm_core)
		objdump_out = conf.cmd_and_log('%s -p "%s"' % (conf.env['OBJDUMP'], os.path.join(conf.env['UNIAUDIO_BUILD_CODEC_PATH'], orig_codec_fn)), env = dict(os.environ)).splitlines()
		soname_line = reduce(lambda a,b : a or b, map(lambda x: x if x.find('SONAME') != -1 else None, objdump_out))
		soname_line = soname_line.strip()
		soname = re.search('SONAME\s*(\S*)', soname_line).group(1)
		print(soname)
		codec_fn = orig_codec_fn

		path = conf.env['UNIAUDIO_TARGET_CODEC_PATH']
		fullpath = os.path.join(path, soname)
		suffix = "%s_%s" % (codec_name.upper(), arm_core.upper())
		conf.env['CODEC_ENTRIES'] += [ { "filename": fullpath, "gstcaps": gstcaps } ]
		Logs.pprint('NORMAL', '  added %s decoder' % desc)
	except Errors.WafError as e:
		Logs.pprint('NORMAL', '  could not add %s decoder' % desc)


def configure_uniaudio_decoder(conf):
	fslcodec_libdirvar = conf.check_cfg(package = 'libfslaudiocodec', args = '--variable=libdir', msg = 'Searching fslcodec plugin directory', okmsg = 'found', errmsg = 'not found', mandatory = 0).strip()
	if not fslcodec_libdirvar:
		Logs.pprint('RED', 'could not find fslcodec plugin directory - not building uniaudio decoder')
		return

	conf.env['UNIAUDIO_BUILD_CODEC_PATH'] = os.path.join(conf.env['LIBPATH_FSLAUDIOCODEC'][0], 'wrap')
	conf.env['UNIAUDIO_TARGET_CODEC_PATH'] = os.path.join(fslcodec_libdirvar, 'wrap')

	conf.env['CODEC_ENTRIES'] = []
	add_fslcodec(conf, "AAC LC", "aacd", "arm12", "audio/mpeg, mpegversion=(int)4, framed=(boolean)true, stream-format=(string){raw,adts,adif}")
	add_fslcodec(conf, "MP3", "mp3d", "arm12", "audio/mpeg, mpegversion=(int)1, layer=(int)3, parsed=(boolean)true")
	add_fslcodec(conf, "Vorbis", "vorbisd", "arm12", "audio/x-vorbis")
	add_fslcodec(conf, "narrowband AMR", "nbamrd", "arm11", "audio/AMR")
	add_fslcodec(conf, "wideband AMR", "wbamrd", "arm12", "audio/AMR-WB")
	add_fslcodec(conf, "WMA", "wma10d", "arm12", "audio/x-wma, wmaversion = (int)[ 1, 4 ]")

	null_terminator = "{ NULL, NULL }"
	if conf.env['CODEC_ENTRIES']:
		codec_str = ','.join(map(lambda x: "{ \"%s\", \"%s\" }" % (x["filename"], x["gstcaps"]), conf.env['CODEC_ENTRIES']))
		conf.define('UNIAUDIO_CODEC_ENTRIES', "{ %s, %s }" % (codec_str, null_terminator), quote = False)
		Logs.pprint('GREEN', 'uniaudio decoder will be built')
	else:
		Logs.pprint('RED', 'no fslcodec plugins found - not building uniaudio decoder')

	conf.env['UNIAUDIO_DECODER_ENABLED'] = 1
	conf.define('WITH_UNIAUDIO_DECODER', 1)


def configure_mp3_encoder(conf):
	if conf.check_cc(lib = '_mp3_enc_arm12_elinux', uselib_store = 'FSLAUDIOCODEC', mandatory = 0):
		conf.env['MP3_ENCODER_ENABLED'] = 1
		conf.define('WITH_MP3_ENCODER', 1)
		Logs.pprint('GREEN', 'mp3 encoder will be built')
	else:
		Logs.pprint('RED', 'mp3 encoder will not be built')


def configure(conf):
	if conf.check_cfg(package = 'libfslaudiocodec', uselib_store = 'FSLAUDIOCODEC', args = '--cflags --libs', mandatory = 0):
		configure_uniaudio_decoder(conf)
		configure_mp3_encoder(conf)
	else:
		Logs.pprint('RED', 'audio plugins will not be built - libfslaudiocodec package not found')


def build(bld):
	base_source = ['plugin.c']
	extra_source = []
	if bld.env['UNIAUDIO_DECODER_ENABLED']:
		extra_source += ['uniaudio_codec.c', 'uniaudio_decoder.c']
	if bld.env['MP3_ENCODER_ENABLED']:
		extra_source += ['mp3_encoder.c']

	if extra_source:
		bld(
			features = ['c', bld.env['CLIBTYPE']],
			includes = ['.', '../..'],
			uselib = bld.env['COMMON_USELIB'] + ['IMX_ASRC', 'KERNEL_HEADERS', 'DL', 'FSLAUDIOCODEC'],
			use = 'gstimxcommon',
			target = 'gstimxaudio',
			source = base_source + extra_source,
			install_path = bld.env['PLUGIN_INSTALL_PATH']
		)

=== blitter/wscript ===
#!/usr/bin/env python


def build(bld):
	import os
	obj = bld(
		features = ['c', bld.env['CLIBTYPE']],
		includes = ['.', '../..', '../common'],
		uselib = bld.env['COMMON_USELIB'],
		use = ['gstimxcommon', 'gstimxcompositor'],
		target = 'gstimxblitter',
		vnum = bld.env['GSTIMX_VERSION'],
		source = bld.path.ant_glob('*.c'),
		defines = ['HAVE_CONFIG_H']
	)
	if bld.env['BUILD_FOR_ANDROID']:
		obj.install_path = os.path.join(bld.env['PREFIX'], 'lib')

=== common/wscript ===
#!/usr/bin/env python


def configure(conf):
	pass


def build(bld):
	import os
	obj = bld(
		features = ['c', bld.env['CLIBTYPE']],
		includes = ['.', '../..'],
		uselib = bld.env['COMMON_USELIB'],
		target = 'gstimxcommon',
		vnum = bld.env['GSTIMX_VERSION'],
		source = bld.path.ant_glob('*.c')
	)
	if bld.env['BUILD_FOR_ANDROID']:
		obj.install_path = os.path.join(bld.env['PREFIX'], 'lib')

=== compositor/wscript ===
#!/usr/bin/env python


def build(bld):
	import os
	bld(
		features = ['c'],
		includes = ['.', '../..', '../common'],
		uselib = bld.env['COMMON_USELIB'] + ['GSTBACKPORT'],
		use = ['gstimxcommon'],
		name = 'gst_aggregator_backport',
		source = bld.path.ant_glob('gst-backport/*.c'),
		defines = ['HAVE_CONFIG_H']
	)
	obj = bld(
		features = ['c', bld.env['CLIBTYPE']],
		includes = ['.', '../..', '../common'],
		uselib = bld.env['COMMON_USELIB'],
		use = ['gstimxcommon', 'gst_aggregator_backport'],
		vnum = bld.env['GSTIMX_VERSION'],
		target = 'gstimxcompositor',
		name = 'gstimxcompositor',
		source = bld.path.ant_glob('*.c'),
		defines = ['HAVE_CONFIG_H']
	)
	if bld.env['BUILD_FOR_ANDROID']:
		obj.install_path = os.path.join(bld.env['PREFIX'], 'lib')

=== eglvivsink/wscript ===
#!/usr/bin/env python


# Try to find one library of a given list
# The first library found is stored in the given uselib_store
def check_lib_list(conf, uselib, uselib_store, lib_list):
	for lib in lib_list:
		if conf.check_cc(mandatory = 0, lib = lib, uselib = uselib, uselib_store = uselib_store):
			return True
	return False

def check_x11(conf, uselib = ''):
	return \
	  conf.check_cc(mandatory = 0, lib = 'X11', uselib = uselib, uselib_store = 'X11') and \
	  conf.check_cc(mandatory = 0, header_name = 'X11/Xlib.h', uselib = uselib, uselib_store = 'X11')

def check_wayland(conf, uselib = ''):
	return \
	  conf.check_cfg(mandatory = 0, package = 'wayland-client', uselib_store = 'WAYLAND_CLIENT', args = '--cflags --libs') and \
	  conf.check_cfg(mandatory = 0, package = 'wayland-cursor', uselib_store = 'WAYLAND_CURSOR', args = '--cflags --libs') and \
	  conf.check_cfg(mandatory = 0, package = 'wayland-egl',    uselib_store = 'WAYLAND_EGL',    args = '--cflags --libs')

def check_gles2(conf, uselib = 'EGL', lib_list = ['GLESv2']):
	retval = \
	  check_lib_list(conf = conf, uselib = uselib, uselib_store = 'GLES2', lib_list = lib_list) and \
	  conf.check_cc(mandatory = 0, header_name = 'GLES2/gl2.h', uselib = uselib, uselib_store = 'GLES2')
	conf.check_cc(mandatory = 0, header_name = ['GLES2/gl2.h', 'GLES2/gl2ext.h'], uselib = uselib, define_name = 'WITH_GL2EXT_H', uselib_store = 'GLES2')
	return retval

def check_vivante_egl(conf, egl_extra_defines):
	if not conf.check_cc(mandatory = 0, lib = ['EGL'], uselib_store = 'EGL'):
		return False
	old_cflags = list(conf.env['CFLAGS'])
	extra_defines = ['LINUX']
	if egl_extra_defines:
		extra_defines += egl_extra_defines
	extra_cflags = map(lambda x: conf.env['DEFINES_ST'] % x, extra_defines)
	conf.env['CFLAGS'] += extra_cflags
	retval = \
		conf.check_cc(mandatory = 0, header_name = 'EGL/eglvivante.h', uselib_store = 'EGL') and \
		conf.check_cc(mandatory = 0, header_name = 'EGL/egl.h', uselib_store = 'EGL')
	conf.env['CFLAGS'] = old_cflags
	if retval:
		conf.env['DEFINES_EGL'] += extra_defines
	return retval

def check_viv_texformat(conf, texformat):
	test_code = """
		#include <GLES2/gl2.h>
		#include <GLES2/gl2ext.h>

		int main()
		{
			return (GL_%s) * 0;
		}
	"""
	return conf.check(fragment = (test_code % texformat), mandatory = 0, execute = 0, define_ret = 0, msg = 'Checking for GLES texture format %s' % texformat, uselib = ['GLES2'], okmsg = 'yes', errmsg = 'no')


valid_egl_platforms = ['fb', 'x11', 'wayland']


def options(opt):
	opt.add_option('--egl-platform', action='store', default='x11', help='EGL platform to build for (valid values: ' + ' '.join(valid_egl_platforms) + ')')


def check_dependencies(conf):
	platform = conf.options.egl_platform
	if platform == "x11":
		if not check_x11(conf) or not check_vivante_egl(conf, None):
			return False
		conf.env['PLATFORM_SOURCE'] = ['egl_platform_x11.c']
		conf.env['PLATFORM_USELIBS'] += ["X11"]
	elif platform == "fb":
		if not check_vivante_egl(conf, ['EGL_API_FB']):
			return False
		conf.env['PLATFORM_SOURCE'] = ['egl_platform_fb.c']
	elif platform == 'wayland':
		if not check_wayland(conf) or not check_vivante_egl(conf, ['EGL_API_FB', 'WL_EGL_PLATFORM']):
			return False
		conf.env['PLATFORM_SOURCE'] = ['egl_platform_wayland.c']
		conf.env['PLATFORM_USELIBS'] += ["WAYLAND_CLIENT", "WAYLAND_CURSOR", "WAYLAND_EGL"]

	if not check_gles2(conf):
		return False

	for texfmt in ['VIV_I420', 'VIV_YV12', 'VIV_NV12', 'VIV_NV21', 'VIV_YUY2', 'VIV_UYVY']:
		if check_viv_texformat(conf, texfmt):
			conf.define('HAVE_' + texfmt, 1)

	return True


def configure(conf):
	from waflib.Build import Logs

	if not conf.options.egl_platform in valid_egl_platforms:
		conf.fatal('Invalid platform selected; run "./waf configure --help" for details about the --egl-platform option')

	if check_dependencies(conf):
		Logs.pprint('GREEN', 'EGL sink with Vivante direct textures will be built')
		Logs.pprint('GREEN', 'Selected EGL platform: ' + conf.options.egl_platform)
		conf.env['EGLVIVSINK_ENABLED'] = 1
	else:
		Logs.pprint('RED', 'EGL sink with Vivante direct textures will not be built - dependencies not found')


def build(bld):
	if bld.env['EGLVIVSINK_ENABLED']:
		bld(
			features = ['c', bld.env['CLIBTYPE']],
			includes = ['../..'],
			use = 'gstimxcommon',
			uselib = ['EGL', 'GLES2'] + bld.env['PLATFORM_USELIBS'] + ['GSTREAMER_VIDEO'] + bld.env['COMMON_USELIB'],
			target = 'gstimxeglvivsink',
			source = ['eglvivsink.c', 'gles2_renderer.c', 'egl_misc.c', 'plugin.c'] + bld.env['PLATFORM_SOURCE'],
			install_path = bld.env['PLUGIN_INSTALL_PATH']
		)

=== g2d/wscript ===
#!/usr/bin/env python


def configure(conf):
	from waflib.Build import Logs
	if conf.check_cc(mandatory = 0, lib = 'g2d', uselib_store = 'IMXG2D') and \
	   conf.check_cc(mandatory = 0, header_name = 'g2d.h', uselib_store = 'IMXG2D'):
		Logs.pprint('GREEN', 'G2D elements will be built')
		conf.env['G2D_ELEMENTS_ENABLED'] = 1
	else:
		Logs.pprint('RED', 'G2D elements will not be built - headers and/or libraries not found')


def build(bld):
	if bld.env['G2D_ELEMENTS_ENABLED']:
		bld(
			features = ['c', bld.env['CLIBTYPE']],
			includes = ['.', '../..'],
			uselib = bld.env['COMMON_USELIB'] + ['IMXG2D'],
			use = ['gstimxcommon', 'gstimxblitter', 'gstimxcompositor'],
			target = 'gstimxg2d',
			source = bld.path.ant_glob('*.c'),
			install_path = bld.env['PLUGIN_INSTALL_PATH']
		)

=== ipu/wscript ===
#!/usr/bin/env python


def configure(conf):
	from waflib.Build import Logs
	if conf.check_cc(fragment = '''
		#include <sys/types.h>
		#include <linux/fb.h>
		#include <linux/ipu.h>

		int main() { return 0; }
		''',
		uselib_store = 'IMXIPU',
		uselib = 'KERNEL_HEADERS',
		mandatory = False,
		execute = False,
		msg = 'checking for linux/fb.h and the IPU header linux/ipu.h'
	):
		Logs.pprint('GREEN', 'IPU elements will be built')
		conf.env['IPU_ELEMENTS_ENABLED'] = 1
	else:
		Logs.pprint('RED', 'IPU elements will not be built - headers not found')


def build(bld):
	if bld.env['IPU_ELEMENTS_ENABLED']:
		bld(
			features = ['c', bld.env['CLIBTYPE']],
			includes = ['.', '../..'],
			uselib = bld.env['COMMON_USELIB'] + ['IMXIPU', 'KERNEL_HEADERS'],
			use = ['gstimxcommon', 'gstimxblitter', 'gstimxcompositor'],
			target = 'gstimxipu',
			source = bld.path.ant_glob('*.c'),
			install_path = bld.env['PLUGIN_INSTALL_PATH']
		)

=== pxp/wscript ===
#!/usr/bin/env python


def configure(conf):
	from waflib.Build import Logs
	if conf.check_cc(fragment = '''
		#include <linux/pxp_device.h>

		int main() { return 0; }
		''',
		uselib_store = 'IMXPXP',
		uselib = 'KERNEL_HEADERS',
		mandatory = False,
		execute = False,
		msg = 'checking for linux/pxp_device.h'
	):
		Logs.pprint('GREEN', 'PxP elements will be built')
		conf.env['PXP_ELEMENTS_ENABLED'] = 1
	else:
		Logs.pprint('RED', 'PxP elements will not be built - headers not found')


def build(bld):
	if bld.env['PXP_ELEMENTS_ENABLED']:
		bld(
			features = ['c', bld.env['CLIBTYPE']],
			includes = ['.', '../..'],
			uselib = bld.env['COMMON_USELIB'] + ['IMXPXP', 'KERNEL_HEADERS'],
			use = ['gstimxcommon', 'gstimxblitter', 'gstimxcompositor'],
			target = 'gstimxpxp',
			source = bld.path.ant_glob('*.c'),
			install_path = bld.env['PLUGIN_INSTALL_PATH']
		)

=== v4l2src/wscript ===
#!/usr/bin/env python


def configure(conf):
	pass


def build(bld):
	if bld.env['WITH_GSTPHOTOGRAPHY']:
		bld(
			features = ['c', bld.env['CLIBTYPE']],
			includes = ['.', '../..'],
			uselib = bld.env['COMMON_USELIB'],
			use = 'gstimxcommon GSTPHOTOGRAPHY',
			target = 'gstimxv4l2videosrc',
			source = bld.path.ant_glob('*.c'),
			install_path = bld.env['PLUGIN_INSTALL_PATH']
		)

=== vpu/wscript ===
#!/usr/bin/env python


from waflib import Logs


def configure(conf):
	if conf.check_cfg(package = 'libimxvpuapi', uselib_store = 'IMXVPUAPI', args = '--cflags --libs', mandatory = 0):
		Logs.pprint('GREEN', 'found installed imxvpuapi library - VPU elements will be built')
		conf.env['BUILD_VPU_ELEMENTS'] = 1
	else:
		Logs.pprint('YELLOW', 'could not find installed imxvpuapi library - VPU elements will not be built')


def build(bld):
	if bld.env['BUILD_VPU_ELEMENTS']:
		bld(
			features = ['c', bld.env['CLIBTYPE']],
			includes = ['.', '../..'],
			uselib = bld.env['COMMON_USELIB'] + ['IMXVPUAPI'],
			use = 'gstimxcommon',
			target = 'gstimxvpu',
			source = bld.path.ant_glob('*.c'),
			install_path = bld.env['PLUGIN_INSTALL_PATH']
		)

=== debian/changelog ===
gstreamer-imx (0.11.1-git813756a) trusty; urgency=low

  * Initial release

 -- Francesco Montefoschi <francesco.monte@gmail.com>  Wed, 02 Dec 2015 15:35:56 +0000

=== debian/control ===
Source: gstreamer-imx
Section: unknown
Priority: optional
Maintainer: Francesco Montefoschi <francesco.monte@gmail.com>
Build-Depends: debhelper (>= 8.0.0), libimxvpuapi0, libimxvpuapi-dev, gstreamer1.0-tools, libgstreamer1.0-dev, gstreamer1.0-plugins-bad, linux-headers, libgstreamer-plugins-base1.0-dev, imx-gpu-viv-9t6-dev, libgstreamer-plugins-good1.0-dev
Standards-Version: 3.9.4
Homepage: https://github.com/Freescale/gstreamer-imx

Package: gstreamer-imx
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: This is a set of GStreamer 1.0 plugins for Freescale's i.MX platform, which make use of the i.MX multimedia capabilities.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ 

override_dh_auto_configure:
	CFLAGS="-g -O2 -fstack-protector --param=ssp-buffer-size=4 -Wformat -Werror=format-security -march=armv7-a -mcpu=cortex-a9 -mtune=cortex-a9 -mfpu=neon -mvectorize-with-neon-quad" ./waf configure --prefix=/usr --kernel-headers=/usr/src/linux-headers-3.14.28-udooqdl/
	
override_dh_auto_build:
	./waf

override_dh_auto_install:
	./waf install --destdir=debian/gstreamer-imx
	mkdir -p $(CURDIR)/debian/gstreamer-imx/usr/lib/arm-linux-gnueabihf
	mv $(CURDIR)/debian/gstreamer-imx/usr/lib/gstreamer-1.0 $(CURDIR)/debian/gstreamer-imx/usr/lib/arm-linux-gnueabihf/gstreamer-1.0

override_dh_auto_clean:
	./waf clean || true
	rm -rf build .waf* .pc .lock-waf_linux2_build || true
